#include <stdio.h>
#include <stdlib.h>


unsigned suma_kratnosti_prostih_faktora(unsigned x) {
  unsigned sk = 0, pf = 2;
  while (x >= pf) {
    while (!(x % pf)) {
      ++sk;
      x /= pf;
    }
    ++pf;
  }
  return sk;
}

unsigned suma_prostih_faktora(unsigned x) {
  unsigned spf = 0, pf = 2;
  while (x >= pf) {
    while (!(x % pf)) {
      spf += pf;
      x /= pf;
    }
    ++pf;
  }
  return spf;
}

unsigned produkt_znamenaka_u_bazi(unsigned x, unsigned b) {
  unsigned p = 1;
  while (x) {
    p *= x % b;
    x /= b;
  }
  return p;
}

unsigned suma_znamenaka_u_bazi(unsigned x, unsigned b) {
  unsigned s = 0;
  while (x) {
    s += x % b;
    x /= b;
  }
  return s;
}


unsigned g1(unsigned x) {
  return suma_kratnosti_prostih_faktora(x);
}

unsigned h1(unsigned x) {
  return produkt_znamenaka_u_bazi(x, 11);
}

unsigned s1(unsigned x) {
  return suma_znamenaka_u_bazi(x, 11);
}

unsigned f1(unsigned x) {
  if (x <= 7)
    return 7 - x;
  if (s1(x) % 2)
    return f1(g1(x + 1));
  return f1(h1(x - 1));
}


unsigned g2(unsigned x) {
  return suma_prostih_faktora(x);
}

unsigned h2(unsigned x) {
  return produkt_znamenaka_u_bazi(x, 13);
}

unsigned s2(unsigned x) {
  return suma_znamenaka_u_bazi(x, 13);
}

unsigned f2(unsigned x) {
  if (x <= 11)
    return 11 - x;
  if (s2(x) % 2)
    return f2(g2(x - 1));
  return f2(h2(x + 1));
}


unsigned g3(unsigned x) {
  return suma_kratnosti_prostih_faktora(x);
}

unsigned h3(unsigned x) {
  return suma_znamenaka_u_bazi(x, 17);
}

unsigned p3(unsigned x) {
  return produkt_znamenaka_u_bazi(x, 17);
}

unsigned f3(unsigned x) {
  if (x <= 9)
    return 9 - x;
  if (p3(x) % 2)
    return f3(g3(2 * x + 1));
  return f3(h3(5 * x - 1));
}


unsigned g4(unsigned x) {
  return suma_prostih_faktora(x);
}

unsigned h4(unsigned x) {
  return suma_znamenaka_u_bazi(x, 19);
}

unsigned p4(unsigned x) {
  return produkt_znamenaka_u_bazi(x, 19);
}

unsigned f4(unsigned x) {
  if (x <= 13)
    return 13 - x;
  if (p4(x) % 2)
    return f4(g4(x + 1713));
  return f4(h4(7 * x - 1));
}


int main() {
  unsigned x;
  printf("x = ");
  scanf("%u", &x);
  printf("f1(%u) = %u.\n", x, f1(x));
  printf("f2(%u) = %u.\n", x, f2(x));
  printf("f3(%u) = %u.\n", x, f3(x));
  printf("f4(%u) = %u.\n", x, f4(x));
  return EXIT_SUCCESS;
}
